(*

Copyright (c) <2011>, <Deepak Garg, garg.deepak@gmail.com>
All rights reserved.

Use in source and binary forms, with or without modification, are
permitted provided that the following conditions are met:

- Code derived from this source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

- Use or modification is not done for any commercial purpose or for
  monetary gain

Redistribution without permission of original copyright holder is
prohibited.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*)

resolve_guard_conj_list (a1 :: a2 :: []) [] sc 

resolve_guard a1 []
(fn NO_EVER => sc NO_EVER
  | NO_NOW => sc NO_NOW
  | YES su' => resolve_guard_conj_list (a2 :: []) su' sc
)

resolve_atom (a1 [])
(fn SOME su' => resolve_guard_conj_list (a2 :: []) su' sc
  | NONE => if Scenario.isFinal (a1 [])
	    then sc NO_EVER else sc NO_NOW
)

resolve_atom (a1 [])
(fn SOME su1 => 
    resolve_guard a2 su1
    (fn NO_EVER => sc NO_EVER
      | NO_NOW => sc NO_NOW
      | YES su2 => resolve_guard_conj_list [] su2 sc
    )
  | NONE => if Scenario.isFinal (a1 [])
	    then sc NO_EVER else sc NO_NOW
)


resolve_atom (a1 [])
(fn SOME su1 => 
    resolve_atom (a2 su1)
    (fn SOME su2 => sc (YES (su1 @ su2))
      | NONE => if Scenario.isFinal (a2 su1) 
		then sc NO_EVER else sc NO_NOW
    )
  | NONE => if Scenario.isFinal (a1 [])
	    then sc NO_EVER else sc NO_NOW
)


