%% Copyright (c) <2011>, <Deepak Garg, garg.deepak@gmail.com>
%% All rights reserved.
%%
%% Use in source and binary forms, with or without modification, are
%% permitted provided that the following conditions are met:
%%
%% - Code derived from this source code must retain the above copyright
%%   notice, this list of conditions and the following disclaimer.
%%
%% - Use or modification is not done for any commercial purpose or for
%%   monetary gain
%%
%% Redistribution without permission of original copyright holder is
%% prohibited.
%%
%% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
%% "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
%% LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
%% A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
%% HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
%% SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
%% LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
%% DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
%% THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
%% (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
%% OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

role: sort.
prin: sort.
attr: sort.

(* Terms *)
 
alice: prin.
bob: prin.
doctorof: prin -> role.
phi: attr.
ci: role.

(* Predicates *)

send: prin - -> prin - -> string - -> date - -> pred DB.

inrole: prin + -> role - -> pred DB.

contains: string + -> prin - -> attr - -> pred EVAL.

inattr: attr + -> attr + -> pred EVAL.

emergency: prin + -> date + -> pred SUBJ.

specialperm: prin + -> pred DB.

add: int + -> int + -> string + -> pred SQL.

